#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

int beepPin = 18;
//****************timer_section*****************
unsigned long previousTMillis = 0;
const unsigned long intervalT[] = {10, 15, 20, 25, 35,36};// время секций профиля

//****************timer_section*****************



boolean BOTTOM_START=false;
boolean TOP_START=false;

char* modeChar[] = {"pc", "tp", "Sn", "Pb"};  //массив символов работа по меню (компорт, термопрофиль, олово, свинец)
int mode_count = 3;                   // № в массиве с "0"
char* sectionChar[] = {"_/", "/-", "-/", "/^", "^|", "|_"};  //массив знасений секций термопрофиля. Работать должен от таймера
int sect_count = 0;                   // № в массиве с "0"

int read_LCD_buttons(){               // read the buttons
    adc_key_in = analogRead(0);       // read the value from the sensor 

    // my buttons when read are centered at these valies: 0, 144, 329, 504, 741
    // we add approx 50 to those values and check to see if we are close
    // We make this the 1st option for speed reasons since it will be the most likely result

    if (adc_key_in > 1000) return btnNONE; 
        
    // For V1.1 us this threshold
    /*
    if (adc_key_in < 50)   return btnRIGHT;  
    if (adc_key_in < 250)  return btnUP; 
    if (adc_key_in < 450)  return btnDOWN; 
    if (adc_key_in < 650)  return btnLEFT; 
    if (adc_key_in < 850)  return btnSELECT;  
    */
   // For V1.0 comment the other threshold and use the one below:
   
     if (adc_key_in < 50)   return btnRIGHT;  
     if (adc_key_in < 195)  return btnUP; 
     if (adc_key_in < 380)  return btnDOWN; 
     if (adc_key_in < 555)  return btnLEFT; 
     if (adc_key_in < 790)  return btnSELECT;   
  

    return btnNONE;                // when all others fail, return this.
}
void init_LCD()
{
   lcd.begin(16, 2);              // start the library
   lcd.setCursor(0,0);            // set the LCD cursor   position 
   lcd.print("ARDUINO REWORK");   // print a simple message on the LCD
   hi_sound ();                   //Welcome melody
   delay(850);
   lcd.clear();
}

   int read_power(int x)
   {
    int result;
    result = map(x, 255, 0, 0, 99);
    return result;
   } 

void init_LCD_key()
{
   
   if (BOTTOM_START)BOTTOM(p_bottom);
   if (TOP_START) TOP(p_top);
   
   lcd.setCursor(0,0);         // move cursor to second line "1" and 9 spaces over
   lcd.print(millis()/1000);   // display seconds elapsed since power-up
   lcd.setCursor(0,1);             // move to the begining of the second line
   lcd_key = read_LCD_buttons();   // read the buttons

   if (btnRIGHT==lcd_key || btnLEFT==lcd_key || btnUP==lcd_key || btnDOWN==lcd_key || btnSELECT==lcd_key)
   {
    key_sound (); 
   }
    
      switch (lcd_key){               // depending on which button was pushed, we perform an action

       case btnRIGHT:{             //  push button "RIGHT" and show the word on the screen
            lcd.print("RIGH");
            
            break;
       }
       case btnLEFT:{
             lcd.print("LEFT"); //  push button "LEFT" and show the word on the screen
             
             break;
       }    
       case btnUP:{
             lcd.print(" UP ");  //  push button "UP" and show the word on the screen
             TOP_START=true;
                                                                                                              
             break;
       }
       case btnDOWN:{
             lcd.print("DOWN");  //  push button "DOWN" and show the word on the screen
             BOTTOM_START=true;
             break;
       }
       case btnSELECT:{
             lcd.print("SEL ");  //  push button "SELECT" and show the word on the screen
             TOP_START=false;TOP(0);
             BOTTOM_START=false;BOTTOM(0);
             break;
       }
       case btnNONE:{
             lcd.print("\1\1\1 ");  //  No action  will show "None" on the screen
             
             
             break;
       }
   }
    
   if(Time>TimeLCD+1000)
   { 
    //************вставка таймера******************
     unsigned long currentMillis = millis();
  if (currentMillis  >= intervalT[sect_count]*1000)
     {    
        if (sect_count < 5)
           {  sect_count ++;
              section_prof ();
           }    
     }
    //************вставка таймера******************
      
    lcd.setCursor(4,0);
    lcd.print('P');
    sprintf ( output_string, "%02i", read_power(DimmerTOP));  lcd.setCursor(5,0); lcd.print(output_string);
    lcd.setCursor(8,0);
    lcd.print('t');
    sprintf ( output_string, "%3i", int(tempTOP));    lcd.setCursor(9,0); lcd.print(output_string);
    lcd.setCursor(13,0);
    lcd.print('M'); //mode режим работы станции: PID, COM, ручной, выбор профиля для PID
    sprintf ( output_string, "%s", modeChar[mode_count]);  lcd.setCursor(14,0); lcd.print(output_string);
    
    lcd.setCursor(4,1);
    lcd.print('P');
    sprintf ( output_string, "%02i", read_power(DimmerA));  lcd.setCursor(5,1); lcd.print(output_string);
    lcd.setCursor(8,1);
    lcd.print('t');
    sprintf ( output_string, "%3i", int(tempBOTTOM)); lcd.setCursor(9,1); lcd.print(output_string);
    lcd.setCursor(13,1);
    lcd.print('S'); //section части профиля по времени (1 преднагрев, 2 активация флюса, 3 начало оплавления, 4 пайка, 5 остывание)
    sprintf ( output_string, "%s", sectionChar[sect_count]);  lcd.setCursor(14,1); lcd.print(output_string);
    
   // sprintf ( output_string, "%02i", read_power(DimmerB));  lcd.setCursor(8,1); lcd.print(output_string);
   //  sprintf ( output_string, "%02i", read_power(DimmerC));  lcd.setCursor(6,1); lcd.print(output_string);
    //  sprintf ( output_string, "%3i", int(Setpoint)); lcd.setCursor(5,1); lcd.print(output_string); 

    //TimeLCD=millis();
   
   }


}


   
