
//MY_Rework 14_14_17
#include <LiquidCrystal.h>
#include <MAX6675.h>
#include <CyberLib.h> //Библиотека от Cyber-Place.ru
volatile uint8_t tic, DimmerA, DimmerB, DimmerC, DimmerTOP, DimmerBOTTOM;
//****************LCD buttons*****************
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);           // select the pins used on the LCD panel

// define some values used by the panel and buttons
int lcd_key     = 0;
int adc_key_in  = 0;

char output_string[5];   //форматированная строка для вывода трех знаков

unsigned long Time;
unsigned long TimeLCD;
unsigned long TimeTEMP;

//****************LCD buttons*****************

//****************timer_section*****************
//unsigned long previousTMillis = 0;
//const unsigned long intervalT[] = {10, 200, 230, 250, 350};

//****************timer_section*****************
//****************остальные инты**************
int b1=0;
int b2=0;
int b3=0;
int p_top, p_bottom;
int t_top, t_bottom;
int state_top, state_bottom;

char buf[32];
unsigned long prev_top, prev_bottom;
int tick = 200;

unsigned long prev_t;
//****************остальные инты**************

//****************MAX6675*********************
int CS0 =   3;    // CS pin on MAX6675
int CS1 =  11;   // CS pin on MAX6675
int SO  =  12;    // SO pin of MAX6675
int SCK1 = 13;    // SCK pin of MAX6675
int units = 1;    // Units to readout temp (0 = ˚F, 1 = ˚C)
int var,var2;
float error1 = 0.0; // Temperature compensation error
float error2 = 0.0; // Temperature compensation error

   MAX6675 temp_t(CS0,SO,SCK1,units,error1);
   MAX6675 temp_b(CS1,SO,SCK1,units,error2);
//****************MAX6675*********************

float tempTOP;
float tempBOTTOM;
int SectionApin = 15;     //Цифровые выходы на включение/выключение секций нижнего нагрева 1-3
int SectionBpin = 16; 
int SectionCpin = 17; 
int TOPpin = 19; 
boolean A=true; boolean B=true; boolean C=true;


void setup() 
 {

  //**************heater*****************
  Serial.begin(9600);
  //pinMode(pin_top, OUTPUT);
  //digitalWrite(pin_top, 0);
  t_top = 3;
  t_bottom = 3;
  p_top = 0;
  p_bottom = 0;

  state_top = LOW;
  state_bottom = LOW;
  prev_top = millis();
  prev_bottom = millis();
  //**************heater*****************
  
   TOP(0);          //выключить. управление верхом от 0 до 99
   BOTTOM(0);       //выключить. управление низ от 0 до 99
   my_Dimmer();     //настройка диммера
   halfcycle();     //прерывания таймера
   detect_up();     // обработка внешнего прерывания. Сработает по переднему фронту
   detect_down();   // обработка внешнего прерывания. Сработает по заднему фронту
   init_LCD();      // инициализация LCD
   smail();         // символы и возможно звуки
   
   Time=millis();
   TimeLCD=millis();
   TimeTEMP=millis();

   pinMode(SectionApin, OUTPUT); digitalWrite(SectionApin, LOW);
   pinMode(SectionBpin, OUTPUT); digitalWrite(SectionBpin, LOW);
   pinMode(SectionCpin, OUTPUT); digitalWrite(SectionCpin, LOW);
   pinMode(TOPpin, OUTPUT);      digitalWrite(TOPpin, LOW);
  
 }
  
  void TOP(int x)
  {
  if (x>99) x=99;
  if(x<0) x=0;
  DimmerTOP=map(x, 99, 0, 0, 255);
  }

  void BOTTOM(int x)
  {
  if (x>99) x=99;
  if(x<0) x=0;
  if (A) DimmerA=map(x, 99, 0, 0, 255); else DimmerA=255;
  if (B) DimmerB=map(x, 99, 0, 0, 255); else DimmerB=255;
  if (C) DimmerC=map(x, 99, 0, 0, 255); else DimmerC=255;
  }
  
void loop() {
   Time=millis();
    
   if(Time>TimeTEMP+250)
   {
    tempTOP    = temp_t.read_temp(1);
    tempBOTTOM = temp_b.read_temp(1);
    TimeTEMP=millis();
   
      //**************heater*****************
     if (Serial.available() > 0)
     {
       b3 = b2; b2 = b1;
       b1 = Serial.read();
       if ((b1 == 'T') && (b2 == 'E') && (b3 == 'S')) {
       p_top = Serial.parseInt(); 
       if (p_top < 0) p_top = 0;
       if (p_top > 100) p_top = 100;
       p_bottom = Serial.parseInt(); 
       if (p_bottom < 0) p_bottom = 0;
       if (p_bottom > 100) p_bottom = 100;
       t_bottom = int(temp_b.read_temp(1));
       t_top = int(temp_t.read_temp(1));
       sprintf (buf, "OK%03d%03d%03d%03d\r\n", p_top, p_bottom, t_top, t_bottom);
       Serial.print(buf);
      } 
     }
   //**************heater*****************

   
   }
   init_LCD_key();             // вывод названия кнопок и реакция на них 
   
}



